//*******************************************************************|
//|                                                  TralingLine.mq4 |
//|                                       Copyright  2010, Viktorov |
//|                                                   v4forex@qip.ru |
//*******************************************************************|
#property copyright "Copyright  2012, Viktorov"
#property link      "v4forex@qip.ru"

extern int     StopLevel   = 20;
extern color   ColorLine   = IndianRed;

double prbuys, prsels, TICKVALUE, FixProfitBuy, FixProfitSel;
int Buy, Sel;

//****************expert initialization function*********************|
   bool     run         = True,
            Error       = False;
   int      slip        =  3;
   double   _Point,
            STOPLEVEL;
   int      _Digits;
int init()
  {
  _Digits = Digits;
  _Point  = Point;
  if((Digits == 3 || Digits == 5))
  {
  _Digits = Digits-1;
  _Point  = Point*10;
  slip   *= 10;
  }
  run = True;
  Error = False;
 TICKVALUE = MarketInfo(Symbol(), MODE_TICKVALUE);

   return(0);
}//******************************************************************|
double   nd(double v){return(NormalizeDouble(v,Digits));}
string   dts(double v){return(DoubleToStr(v, Digits));}
string   dts2(double v){return(DoubleToStr(v, 2));}
string   ttss(int v){return(TimeToStr(v,TIME_SECONDS));}
//*******************************************************************|
//|                     expert start function                        |
//*******************************************************************|
int start()
{
     double nprbuys, nprsels;
   int ticket;
  if(IsTradeAllowed())
  {
    CountTrades();
   
   if(Buy > 0 && ObjectFind("StopBuy") == -1) drawline(OP_BUY);
   if(Sel > 0 && ObjectFind("StopSel") == -1) drawline(OP_SELL);
   if(ObjectFind("StopBuy") != -1)
   nprbuys = ObjectGetValueByShift("StopBuy", 0);
   if(ObjectFind("StopSel")!=-1)
   nprsels = ObjectGetValueByShift("StopSel", 0);
   
   if(nprbuys > 0 && Bid <= nprbuys)
   {
    CloseOrder(OP_BUY);
    if(ObjectFind("StopBuy") != -1) ObjectDelete("StopBuy");
   }
   if(nprsels > 0 && Ask >= nprsels)
   {
    CloseOrder(OP_SELL);
    if(ObjectFind("StopSel") != -1) ObjectDelete("StopSel");
   }
      FixProfit();
   if(Buy == 0) ObjectDelete("StopBuy");
   if(Sel == 0) ObjectDelete("StopSel");
 }
   Comment("\n    ", ttss(TimeCurrent())
         , "\n  Buy    ", dts(nprbuys), ".   ", dts2(FixProfitBuy)
         , "\n  Sell    ", dts(nprsels), ".   ", dts2(FixProfitSel)
         );
   return(0);
}//******************************************************************|
  
//********************   *******************| 
void FixProfit()
{  double LineB, LineS, Profit, tv;
   LineB = nd(ObjectGetValueByShift("StopBuy", 0));
   LineS = nd(ObjectGetValueByShift("StopSel", 0));
    tv = TICKVALUE; FixProfitBuy = 0; FixProfitSel = 0;
     int Total = OrdersTotal();
   
   for(int i = Total-1; i >= 0; i--)
    {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
     if(OrderSymbol() == Symbol())
       {
        if(OrderType() == OP_BUY && LineB > 0)
         {
          if(StringSubstr(Symbol(),0,3) == "USD") tv = TICKVALUE*Bid/LineB;
          FixProfitBuy += (OrderCommission() + OrderSwap() + (LineB - OrderOpenPrice())*tv*OrderLots()/Point);
         } 
        if(OrderType() == OP_SELL && LineS > 0)
         {
          if(StringSubstr(Symbol(),0,3) == "USD") tv = TICKVALUE*Bid/LineS;
          FixProfitSel += (OrderCommission() + OrderSwap() + (OrderOpenPrice() - LineS)*tv*OrderLots()/Point);
         } 
       }
     Profit += OrderProfit();
     }
    }
}//******************************************************************|

//*******   OP_BUY & OP_SELL*******************|
        void CountTrades()
           {   Buy = 0; Sel = 0;
            int Total = OrdersTotal();
            for(int i = 0; i < Total; i++)
             {
              if(OrderSelect(i, SELECT_BY_POS))
              {
              if(OrderSymbol() == Symbol())
               {
               if(OrderType() == OP_BUY) Buy++;
                  if(OrderType() ==  OP_SELL) Sel++;
               }
              }
             }//for
           }//*******************************************************|

//********************** ******************************|
void drawline(int sig)
   {
    if(sig == OP_BUY)
     {
      prbuys = Bid - (Period() + StopLevel) * _Point;
      ObjectCreate("StopBuy", OBJ_TREND, 0, Time[0]+2*Period()*60, prbuys, Time[0]+20*Period()*60, prbuys); 
      ObjectSet("StopBuy", OBJPROP_COLOR, ColorLine);
      ObjectSet("StopBuy", OBJPROP_STYLE, STYLE_DOT);
     }
    if(sig == OP_SELL)
     {
      prsels = Ask + (Period() + StopLevel) * _Point;
      ObjectCreate("StopSel", OBJ_TREND, 0, Time[0]+2*Period()*60, prsels, Time[0]+20*Period()*60, prsels);   
      ObjectSet("StopSel", OBJPROP_COLOR, ColorLine);
      ObjectSet("StopSel", OBJPROP_STYLE, STYLE_DOT);
     }
   return;
}//******************************************************************|

//******************** *******************************|
void CloseOrder(int sig)
{     double GH, FE, CloseLot, c = 0; bool OrdClose; int Total = OrdersTotal();

            for(int i = 0; i < Total; i++)
              {
               OrdClose = False;
   if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == Symbol())
      {
      if(OrderType() == sig)
       {
      while(!OrdClose) //    8 
            {
      RefreshRates();
        if(OrderType() == OP_BUY)  GH = Bid;
   else if(OrderType() == OP_SELL) GH = Ask;
      OrdClose =  OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(GH, Digits), slip, CLR_NONE);
               if(OrdClose) i--;
         if(!OrdClose)
         {
      FE = Fun_Error(GetLastError());
            if(FE == 1) {  continue;   } //  
       else if(FE == 0) { Print("  CloseOrder Error = ", GetLastError()); return;}
       else {  Print("  CloseOrder"); return;   }
         }
            } //  while(c < 8)
       }
      }
              }//for
   return;
}//******************************************************************|

//*********************-  *************************|
int Fun_Error(int Error) 
{
      switch(Error)
   { //  
   case 0: return(1);
   case 4: Print("  .   ...");
   Sleep(3000); //  
   return(1); //   
   case 135: Print(" .   ...");
   RefreshRates(); //  
   return(1); //   
   case 136: Print(" .   ...");
   while(RefreshRates()==false) //   
   Sleep(1); //   
   return(1); //   
   case 137: Print(" .   ...");
   Sleep(3000); //  
   return(1); //   
   case 138: //Print(" .   ...");
   Sleep(1); //   
   return(1); //   
   case 146: Print("  .  ...");
   Sleep(500); //  
   return(1); //   
   case 4107: Print("     .  ...");
   Sleep(50); //  
   return(1); //   
//  
   case 2: Alert(" .   \ .");
   return(0); //   
   case 5: Alert("  .");
   //Work=false; //   
   return(0); //   
   case 64: Alert(" .");
   //Work=false; //   
   return(0); //   
   case 133: Alert(" .");
   return(0); //   
   case 134: Alert("    .");
   return(0); //   
   case 4051: Alert("   .");
   return(0); //   
   default: //Print("  ",Error); //  
   return(2); //   
   }
}//******************************************************************|

//****************expert deinitialization function*******************|
int deinit()
  {
  Comment("");
  ObjectDelete("StopBuy");
  ObjectDelete("StopSel");
   return(0);
}//******************************************************************|

